// List Object
// Copyright 1999 Dan Steinman
// Available at the Dynamic Duo (http://www.dansteinman.com/dynduo/)
// Feb 1, 1999.
// In order to use this code you must keep this disclaimer

function List(x,y,width,itemH) {
	this.name = "List"+(List.count++)
	this.x = x
	this.y = y
	this.w = width
	if (arguments.length==4) {
		this.itemH = itemH
		this.itemHset = true
		this.h = -1
	}
	else {
		this.itemH = null
		this.itemHset = false
		this.h = (ns4)? -1 : 1000
	}

	this.itemSpacing = 1
	this.fontname = 'Helvetica'
	this.fontsize = 11
	this.visibility = 'inherit'

	this.color = new Object()
	this.color.textNormal = '#000000'
	this.color.textSelected = '#FFFFFF'
	this.color.bgNormal = '#E6E6E6'
	this.color.bgSelected = '#0000A0'
	this.color.bgRollover = '#D1D1D1'
	this.color.bg = '#C0C0C0'

	this.allowDeselect = false
	this.multiSelect = false
	this.preSelect = null

	this.items = new Array()
	this.selectedIndex = null
	this.obj = this.name + "ListObject"
	eval(this.obj + "=this")

	this.add = ListAdd
	this.build = ListBuild
	this.activate = ListActivate
	this.over = ListOver
	this.out = ListOut
	this.down = ListDown
	this.select = ListSelect
	this.setCols = ListSetCols
	this.image = new Object()
	this.setImage = ListSetImage
	this.deselect = ListDeselect
	this.onSelect = new Function()
}
function ListSetCols() {
	this.cols = arguments
	this.multiCol = true
}
function ListSetImage(image0,image1,width,height) {
	this.image.image0 = new Image()
	this.image.image0.src = image0
	this.image.image1 = new Image()
	this.image.image1.src = image1
	this.image.w = width
	this.image.h = height
}
function ListAdd(value) {
	var i = this.items.length
	this.items[i] = new Array()
	this.items[i].selected = false
	this.items[i].value = value
	if (arguments.length>2) {
		this.items[i].textNormal = this.items[i].textSelected = '<table border=0 cellpadding=0 cellspacing=0><tr>'
		this.items[i].text = new Array()
		for (var j=1;j<arguments.length;j++) {
			this.items[i].text[j-1] = arguments[j]
			this.items[i].textNormal += '<td width='+this.cols[j-1]+'><div class="'+this.name+'TextNormal">'+arguments[j]+'</div></td>'
			this.items[i].textSelected += '<td width='+this.cols[j-1]+'><div class="'+this.name+'TextSelected">'+arguments[j]+'</div></td>'
		}
		this.items[i].textNormal += '</tr></table>'
		this.items[i].textSelected += '</tr></table>'
	}
	else {
		this.items[i].text = arguments[1]
		this.items[i].textNormal = '<div class="'+this.name+'TextNormal">'+arguments[1]+'</div>'
		this.items[i].textSelected = '<div class="'+this.name+'TextSelected">'+arguments[1]+'</div>'
	}
	if (this.itemH) {
		this.h += this.itemH+this.itemSpacing
		this.items[i].y = i*this.itemH+i*this.itemSpacing
	}
	else this.items[i].y = 0
}
function ListBuild() {
	this.css = ''
	this.css += css(this.name+'List',this.x,this.y,this.w,this.h,this.color.bg,(this.itemHset)?this.visibility:'hidden')
	for (var i=0;i<this.items.length;i++) {
		this.css += css(this.name+'ListItem'+i,0,this.items[i].y,this.w,this.itemH,this.color.bgNormal)
		if (this.items[i].hasImage) this.css += css(this.name+'ListItemImgLyr'+i,this.w-this.image.w,this.items[i].y)
		this.css += css(this.name+'ListItemC'+i,0,this.items[i].y,this.w,this.itemH)
	}
	this.css += '.'+this.name+'TextNormal {font-family:"'+this.fontname+'"; font-size:'+this.fontsize+'pt; color:'+this.color.textNormal+'; background-color:transparent;}\n'+
	'.'+this.name+'TextSelected {font-family:"'+this.fontname+'"; font-size:'+this.fontsize+'pt; color:'+this.color.textSelected+'; background-color:transparent;}\n'
	
	this.div = '<div id="'+this.name+'List">\n'
	for (var i=0;i<this.items.length;i++) {
		this.div += '<div id="'+this.name+'ListItem'+i+'">'+this.items[i].textNormal+'</div>\n'
		if (this.items[i].hasImage) this.div += '<div id="'+this.name+'ListItemImgLyr'+i+'"><img name="'+this.name+'ListItemImg'+i+'" src="'+this.image.image0.src+'" width='+this.image.w+' height='+this.image.h+'></div>\n'
		this.div += '<div id="'+this.name+'ListItemC'+i+'"></div>\n'
	}
	this.div += '</div>'
}
function ListActivate() {
	if (ie4) this.h -= 1001
	this.lyr = new DynLayer(this.name+'List')
	this.lyr.clipInit()
	for (var i=0;i<this.items.length;i++) {
		this.items[i].lyr = new DynLayer(this.name+'ListItem'+i)
		this.items[i].lyr.setbg = DynLayerSetbg
		this.items[i].lyre = new DynLayer(this.name+'ListItemC'+i)
		if (ns4) this.items[i].lyre.event.captureEvents(Event.MOUSEDOWN)
		this.items[i].lyre.event.onmouseover = new Function(this.obj+'.over('+i+'); return false;')
		this.items[i].lyre.event.onmouseout = new Function(this.obj+'.out('+i+'); return false;')
		this.items[i].lyre.event.onmousedown = new Function(this.obj+'.down('+i+'); return false;')
		if (!this.itemHset) {
			this.itemH = (ns4)? this.items[0].lyr.doc.height : this.items[0].lyr.event.offsetHeight
			this.items[i].lyr.moveTo(null,i*this.itemH+this.itemSpacing*i)
			this.items[i].lyre.moveTo(null,i*this.itemH+this.itemSpacing*i)
			if (ns4) {
				this.items[i].lyr.clipInit()
				this.items[i].lyr.clipTo(0,this.w,this.itemH,0)
				this.items[i].lyre.clipInit()
				this.items[i].lyre.clipTo(0,this.w,this.itemH,0)
			}
			this.h += this.itemH+this.itemSpacing
		}
		if (this.items[i].hasImage) {
			this.items[i].imagelyr = new DynLayer(this.name+'ListItemImgLyr'+i)
		}
	}
	if (!this.itemHset) {
		this.lyr.clipTo(0,this.w,this.h,0)
		if (ie4) this.lyr.css.height = this.h
	}
	if (this.preSelect!=null) this.select(this.preSelect)
	this.lyr.css.visibility = this.visibility
}
function ListOver(i) {
	if (!this.items[i].selected) this.items[i].lyr.setbg(this.color.bgRollover)
}
function ListOut(i) {
	if (!this.items[i].selected) this.items[i].lyr.setbg(this.color.bgNormal)
}
function ListDown(i) {
	if (!this.items[i].selected) {
		if (!this.multiSelect) this.deselect(this.selectedIndex)
		this.select(i)
		this.onSelect()
	}
	else {
		if (this.multiSelect || this.allowDeselect) {
			this.deselect(i)
			this.onSelect()
		}
	}
}
function ListSelect(index) {
	if (this.items[index]!=null) {	
		this.selectedIndex = index
		this.value = this.items[index].value
		if (this.items[index].hasImage) this.items[index].imagelyr.doc.images[this.name+'ListItemImg'+index].src = this.image.image1.src
		this.items[index].lyr.setbg(this.color.bgSelected)
		this.items[index].lyr.write(this.items[index].textSelected)
		this.items[index].selected = true
	}
}
function ListDeselect(index) {
	if (this.items[index]!=null) {
		if (this.items[index].selected) {
		if (this.items[index].hasImage) this.items[index].imagelyr.doc.images[this.name+'ListItemImg'+index].src = this.image.image0.src
		this.items[index].lyr.setbg(this.color.bgNormal)
		this.items[index].lyr.write(this.items[index].textNormal)
		this.items[index].selected = false
		}
	}
}
function ListRedirect() {
	location.href = this.value
}
List.count = 0

// Dynlayer setbg() required
function DynLayerSetbg(color) {
	if (ns4) this.doc.bgColor = color
	else if (ie4) this.css.backgroundColor = color
}
